const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Benefit_plansDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const benefit_plans = await db.benefit_plans.create(
      {
        id: data.id || undefined,

        carrier: data.carrier || null,
        plan_type: data.plan_type || null,
        country: data.country || null,
        currency: data.currency || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await benefit_plans.setOrganizations(data.organizations || null, {
      transaction,
    });

    return benefit_plans;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const benefit_plansData = data.map((item, index) => ({
      id: item.id || undefined,

      carrier: item.carrier || null,
      plan_type: item.plan_type || null,
      country: item.country || null,
      currency: item.currency || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const benefit_plans = await db.benefit_plans.bulkCreate(benefit_plansData, {
      transaction,
    });

    // For each item created, replace relation files

    return benefit_plans;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const benefit_plans = await db.benefit_plans.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.carrier !== undefined) updatePayload.carrier = data.carrier;

    if (data.plan_type !== undefined) updatePayload.plan_type = data.plan_type;

    if (data.country !== undefined) updatePayload.country = data.country;

    if (data.currency !== undefined) updatePayload.currency = data.currency;

    updatePayload.updatedById = currentUser.id;

    await benefit_plans.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await benefit_plans.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return benefit_plans;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const benefit_plans = await db.benefit_plans.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of benefit_plans) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of benefit_plans) {
        await record.destroy({ transaction });
      }
    });

    return benefit_plans;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const benefit_plans = await db.benefit_plans.findByPk(id, options);

    await benefit_plans.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await benefit_plans.destroy({
      transaction,
    });

    return benefit_plans;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const benefit_plans = await db.benefit_plans.findOne(
      { where },
      { transaction },
    );

    if (!benefit_plans) {
      return benefit_plans;
    }

    const output = benefit_plans.get({ plain: true });

    output.enrollments_plan = await benefit_plans.getEnrollments_plan({
      transaction,
    });

    output.organizations = await benefit_plans.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.carrier) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('benefit_plans', 'carrier', filter.carrier),
        };
      }

      if (filter.country) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('benefit_plans', 'country', filter.country),
        };
      }

      if (filter.currency) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('benefit_plans', 'currency', filter.currency),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.plan_type) {
        where = {
          ...where,
          plan_type: filter.plan_type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.benefit_plans.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('benefit_plans', 'carrier', query),
        ],
      };
    }

    const records = await db.benefit_plans.findAll({
      attributes: ['id', 'carrier'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['carrier', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.carrier,
    }));
  }
};
